## API Report File for "@fluentui/react-utilities"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { DispatchWithoutAction } from 'react';
import * as React_2 from 'react';

// @public
export const anchorProperties: Record<string, number>;

// @public
export const applyTriggerPropsToChildren: <TTriggerProps>(children: React_2.ReactElement<any, string | ((props: any) => React_2.ReactElement<any, string | any | (new (props: any) => React_2.Component<any, any, any>)> | null) | (new (props: any) => React_2.Component<any, any, any>)> | ((props: TTriggerProps) => React_2.ReactNode) | null | undefined, triggerProps: TTriggerProps) => React_2.ReactNode;

// @public
export type AsIntrinsicElement<As extends keyof JSX.IntrinsicElements> = {
    as?: As;
};

// @public
export const audioProperties: Record<string, number>;

// @public
export const baseElementEvents: Record<string, number>;

// @public
export const baseElementProperties: Record<string, number>;

// @public (undocumented)
export type BaseSlotsCompat = {
    root: React_2.ElementType;
};

// @public
export const buttonProperties: Record<string, number>;

// @public
export function canUseDOM(): boolean;

// @public (undocumented)
export type ChangeCallback<TElement extends HTMLElement, TValue, TEvent extends React_2.SyntheticEvent<TElement> | undefined> = (ev: TEvent, newValue: TValue | undefined) => void;

// @public
export const clamp: (value: number, min: number, max: number) => number;

// @public (undocumented)
export const colGroupProperties: Record<string, number>;

// @public (undocumented)
export const colProperties: Record<string, number>;

// @public (undocumented)
export type ComponentProps<Shorthands extends ObjectShorthandPropsRecord, Primary extends keyof Shorthands = 'root'> = Omit<{
    [Key in keyof Shorthands]?: ShorthandProps<NonNullable<Shorthands[Key]>>;
}, Primary> & PropsWithoutRef<Shorthands[Primary]>;

// @public (undocumented)
export type ComponentPropsCompat = {
    as?: React_2.ElementType;
    className?: string;
    children?: React_2.ReactNode;
};

// @public (undocumented)
export type ComponentState<Shorthands extends ObjectShorthandPropsRecord> = {
    components?: {
        [Key in keyof Shorthands]-?: React_2.ComponentType<NonNullable<Shorthands[Key]> extends ObjectShorthandProps<infer P> ? P : NonNullable<Shorthands[Key]>> | (NonNullable<Shorthands[Key]> extends AsIntrinsicElement<infer As> ? As : keyof JSX.IntrinsicElements);
    };
} & Shorthands;

// @public
export type ComponentStateCompat<Props, ShorthandPropNames extends keyof Props = never, DefaultedPropNames extends keyof ResolvedShorthandPropsCompat<Props, ShorthandPropNames> = never> = RequiredPropsCompat<ResolvedShorthandPropsCompat<Props, ShorthandPropNames>, DefaultedPropNames>;

// @public
export type DefaultObjectShorthandProps = ObjectShorthandProps<{
    children?: React_2.ReactNode;
    as?: keyof JSX.IntrinsicElements;
}>;

// Warning: (ae-internal-missing-underscore) The name "defaultSSRContextValue" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export const defaultSSRContextValue: SSRContextValue;

// @public
export const divProperties: Record<string, number>;

// @public
export const formProperties: Record<string, number>;

// @public
export function getNativeElementProps<TAttributes extends React_2.HTMLAttributes<any>>(tagName: string, props: {}, excludedPropNames?: string[]): TAttributes;

// @public
export function getNativeProps<T extends Record<string, any>>(props: Record<string, any>, allowedPropNames: string[] | Record<string, number>, excludedPropNames?: string[]): T;

// @public
export const getRTLSafeKey: (key: string, dir: 'ltr' | 'rtl') => string;

// @public
export function getSlots<R extends ObjectShorthandPropsRecord>(state: ComponentState<R>, slotNames?: (keyof R)[]): {
    slots: Slots<R>;
    slotProps: SlotProps<R>;
};

// Warning: (ae-forgotten-export) The symbol "GenericDictionary" needs to be exported by the entry point index.d.ts
//
// @public
export const getSlotsCompat: (state: GenericDictionary, slotNames?: readonly string[] | undefined) => {
    slots: Record<string, any>;
    slotProps: Record<string, any>;
};

// @public
export const htmlElementProperties: Record<string, number>;

// @public
export const iframeProperties: Record<string, number>;

// @public @deprecated (undocumented)
export const imageProperties: Record<string, number>;

// @public
export const imgProperties: Record<string, number>;

// @public
export const inputProperties: Record<string, number>;

// @public
export type IntrinsicShorthandProps<DefaultAs extends keyof JSX.IntrinsicElements, AlternateAs extends keyof JSX.IntrinsicElements = never> = IsSingleton<DefaultAs> extends false ? 'Error: first parameter to IntrinsicShorthandProps must be a single element type, not a union of types' : ({
    as?: DefaultAs;
} & ObjectShorthandProps<React_2.PropsWithRef<JSX.IntrinsicElements[DefaultAs]>>) | {
    [As in AlternateAs]: {
        as: As;
    } & ObjectShorthandProps<React_2.PropsWithRef<JSX.IntrinsicElements[As]>>;
}[AlternateAs];

// @public
export type IsSingleton<T extends string> = {
    [K in T]: Exclude<T, K> extends never ? true : false;
}[T];

// @public
export const labelProperties: Record<string, number>;

// @public
export const liProperties: Record<string, number>;

// @public
export const makeMergeProps: <TState>(options?: MergePropsOptions<TState>) => (target: TState, ...propSets: (Partial<TState> | undefined)[]) => TState;

// Warning: (ae-forgotten-export) The symbol "GenericDictionary" needs to be exported by the entry point index.d.ts
//
// @public @deprecated
export const makeMergePropsCompat: <TState = Record<string, any>>(options?: MergePropsOptions<Record<string, any>> | undefined) => (target: GenericDictionary_2, ...propSets: (GenericDictionary_2 | undefined)[]) => TState;

// @public (undocumented)
export type MergePropsOptions<TState> = {
    deepMerge?: readonly (keyof TState)[];
};

// @public
export const nullRender: () => null;

// @public
export type ObjectShorthandProps<Props extends {
    children?: React_2.ReactNode;
} = {}> = Props & {
    children?: Props['children'] | ShorthandRenderFunction<Props>;
};

// @public (undocumented)
export type ObjectShorthandPropsCompat<TProps extends ComponentPropsCompat = {}> = TProps & Omit<ComponentPropsCompat, 'children'> & {
    children?: TProps['children'] | ShorthandRenderFunctionCompat<TProps>;
};

// @public (undocumented)
export type ObjectShorthandPropsRecord = Record<string, DefaultObjectShorthandProps | undefined>;

// @public
export const olProperties: Record<string, number>;

// @public
export function omit<TObj extends Record<string, any>, Exclusions extends (keyof TObj)[]>(obj: TObj, exclusions: Exclusions): Omit<TObj, Exclusions[number]>;

// @public
export const onlyChild: <P>(child: string | number | boolean | {} | React_2.ReactNodeArray | React_2.ReactPortal | React_2.ReactElement<P, string | ((props: any) => React_2.ReactElement<any, string | any | (new (props: any) => React_2.Component<any, any, any>)> | null) | (new (props: any) => React_2.Component<any, any, any>)> | null | undefined) => React_2.ReactElement<P, string | ((props: any) => React_2.ReactElement<any, string | any | (new (props: any) => React_2.Component<any, any, any>)> | null) | (new (props: any) => React_2.Component<any, any, any>)>;

// @public (undocumented)
export const optionProperties: Record<string, number>;

// @public
export type PropsWithoutRef<P> = 'ref' extends keyof P ? (P extends unknown ? Omit<P, 'ref'> : P) : P;

// @public
export type RefObjectFunction<T> = React_2.RefObject<T> & ((value: T) => void);

// @public
export type RequiredPropsCompat<T, K extends keyof T> = Omit<T, K> & {
    [P in K]-?: T[P];
};

// @public
export function resetIdsForTests(): void;

// @public
export type ResolvedShorthandPropsCompat<T, K extends keyof T> = Omit<T, K> & {
    [P in K]: T[P] extends ShorthandPropsCompat<infer U> ? ObjectShorthandPropsCompat<U> : T[P];
};

// @public
export function resolveShorthand<Props extends DefaultObjectShorthandProps, Required extends boolean = false>(value: ShorthandProps<Props>, options?: ResolveShorthandOptions<Props, Required>): Required extends false ? Props | undefined : Props;

// @public (undocumented)
export type ResolveShorthandOptions<Props extends Record<string, any>, Required extends boolean = false> = {
    required?: Required;
    defaultProps?: Props;
};

// @public
export const resolveShorthandProps: <TProps, TShorthandPropNames extends keyof TProps>(props: TProps, shorthandPropNames: readonly TShorthandPropNames[]) => ResolvedShorthandPropsCompat<TProps, TShorthandPropNames>;

// @public
export const selectProperties: Record<string, number>;

// @public (undocumented)
export type ShorthandProps<Props extends DefaultObjectShorthandProps> = React_2.ReactChild | React_2.ReactNodeArray | React_2.ReactPortal | number | null | undefined | Props;

// @public (undocumented)
export type ShorthandPropsCompat<TProps extends ComponentPropsCompat = {}> = React_2.ReactChild | React_2.ReactNodeArray | React_2.ReactPortal | number | null | undefined | ObjectShorthandPropsCompat<TProps>;

// @public (undocumented)
export type ShorthandRenderFunction<Props> = (Component: React_2.ElementType<Props>, props: Omit<Props, 'children' | 'as'>) => React_2.ReactNode;

// @public (undocumented)
export type ShorthandRenderFunctionCompat<TProps> = (Component: React_2.ElementType<TProps>, props: TProps) => React_2.ReactNode;

// @public
export function shouldPreventDefaultOnKeyDown(e: KeyboardEvent | React_2.KeyboardEvent): boolean;

// @public (undocumented)
export type SlotPropsCompat<TSlots extends BaseSlotsCompat, TProps, TRootProps extends React_2.HTMLAttributes<HTMLElement>> = {
    [key in keyof Omit<TSlots, 'root'>]: key extends keyof TProps ? TProps[key] : any;
} & {
    root: TRootProps;
};

// @public (undocumented)
export type Slots<S extends ObjectShorthandPropsRecord> = {
    [K in keyof S]-?: NonNullable<S[K]> extends AsIntrinsicElement<infer As> ? As : S[K] extends ObjectShorthandProps<infer P> ? React_2.ElementType<NonNullable<P>> : React_2.ElementType<NonNullable<S[K]>>;
};

// Warning: (ae-incompatible-release-tags) The symbol "SSRContext" is marked as @public, but its signature references "SSRContextValue" which is marked as @internal
//
// @public (undocumented)
export const SSRContext: React_2.Context<SSRContextValue>;

// Warning: (ae-internal-missing-underscore) The name "SSRContextValue" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export type SSRContextValue = {
    current: number;
};

// @public
export const SSRProvider: React_2.FC;

// @public
export const tableProperties: Record<string, number>;

// @public
export const tdProperties: Record<string, number>;

// @public
export const textAreaProperties: Record<string, number>;

// @public
export const thProperties: Record<string, number>;

// @public
export const trProperties: Record<string, number>;

// @public
export type UnionToIntersection<U> = (U extends unknown ? (x: U) => U : never) extends (x: infer I) => U ? I : never;

// @public
export function useBoolean(initialState: boolean): [boolean, UseBooleanCallbacks];

// @public
export type UseBooleanCallbacks = {
    setTrue: () => void;
    setFalse: () => void;
    toggle: () => void;
};

// @public
export function useConst<T>(initialValue: T | (() => T)): T;

// @public
export const useControllableState: <State>(options: UseControllableStateOptions<State>) => [State, React_2.Dispatch<React_2.SetStateAction<State>>];

// @public (undocumented)
export type UseControllableStateOptions<State> = {
    defaultState?: State | (() => State);
    state: State | undefined;
    initialState: State;
};

// Warning: (ae-forgotten-export) The symbol "DefaultValue" needs to be exported by the entry point index.d.ts
//
// @public
export function useControllableValue<TValue, TElement extends HTMLElement>(controlledValue: TValue, defaultUncontrolledValue: DefaultValue<TValue>): Readonly<[TValue, (update: React_2.SetStateAction<TValue>) => void]>;

// @public (undocumented)
export function useControllableValue<TValue, TElement extends HTMLElement, TEvent extends React_2.SyntheticEvent<TElement> | undefined>(controlledValue: TValue, defaultUncontrolledValue: DefaultValue<TValue>, onChange: ChangeCallback<TElement, TValue, TEvent>): Readonly<[TValue, (update: React_2.SetStateAction<TValue>, ev?: React_2.FormEvent<TElement>) => void]>;

// @public
export const useEventCallback: <Args extends unknown[], Return>(fn: (...args: Args) => Return) => (...args: Args) => Return;

// @public
export function useFirstMount(): boolean;

// @public
export function useForceUpdate(): DispatchWithoutAction;

// @public
export function useId(prefix?: string, providedId?: string): string;

// @public
export const useIsomorphicLayoutEffect: typeof React_2.useEffect;

// @public
export function useIsSSR(): boolean;

// @public
export function useMergedRefs<T>(...refs: (React_2.Ref<T> | undefined)[]): RefObjectFunction<T>;

// @public
export const useMount: (callback: () => void) => void;

// @public (undocumented)
export type UseOnClickOrScrollOutsideOptions = {
    element: Document | undefined;
    refs: React_2.MutableRefObject<HTMLElement | undefined | null>[];
    contains?(parent: HTMLElement | null, child: HTMLElement): boolean;
    disabled?: boolean;
    callback: (ev: MouseEvent | TouchEvent) => void;
};

// @public
export const useOnClickOutside: (options: UseOnClickOrScrollOutsideOptions) => void;

// @public
export const useOnScrollOutside: (options: UseOnClickOrScrollOutsideOptions) => void;

// @public (undocumented)
export const usePrevious: <ValueType = unknown>(value: ValueType) => ValueType | null;

// Warning: (ae-internal-missing-underscore) The name "useSSRContext" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export function useSSRContext(): SSRContextValue;

// @public
export function useTimeout(): readonly [(fn: () => void, delay: number) => void, () => void];

// @public
export const useUnmount: (callback: () => void) => void;

// @public
export const videoProperties: Record<string, number>;

// Warnings were encountered during analysis:
//
// lib/compose/getSlots.d.ts:27:5 - (ae-forgotten-export) The symbol "SlotProps" needs to be exported by the entry point index.d.ts

// (No @packageDocumentation comment for this package)

```
